#!/usr/bin/perl
# Copyright (C) 2007, 2008  Condel project, TU-Berlin.
# Written by Jiehua Chen, Sven Grottke, Jan Sablatnig.
# 
# This file is part of Adam, the DVE testbed.
# 
# Adam is free software: you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free
# Software Foundation, either version 3, or (at your option) any later
# version.
# 
# Adam is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Adam; see the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.
# 
# Contact the Condel project at <http://www.math.tu-berlin.de/condel/>.


# usage: avg_measurement.pl SCAFILE_NAME 
use strict;

# GLOBAL VARIABLES
my %HashData;

sub usage{
    print STDERR "usage: avg_measurement.pl SCAFILE_NAME\n";
}

sub failure{
    my $failedparm = shift;
    
    if ( defined $failedparm ){
        print STDERR "$failedparm format is wrong\n";
    }
    else{
        print STDERR "parameters failed!\n";
      }
    &usage;
    print STDERR "Please see the usage for more details.\n";
    die "aborting.";
}

if( @ARGV  != 1 ) { &failure("parameter failed!"); }

open(SCAFILE,"$ARGV[0]");
#print "open: $ARGV[0]\n";
#my $host = $ARGV[1];
my @sca_lines = <SCAFILE>;
#map { s/(\W)/\\$1/g; } @sca_lines;
#$host =~ s/(\W)/\\$1/g;
#print "$host\n";
# calculate the avg. value of each measurename appeared in SCA
my $network;
foreach ( @sca_lines ){
#    print "$_";
    if( /\"(.*[\d|\]])\"\s+\"(.*?)\"\s+([\.\d\-e]+)/ ){
        $HashData{$2}{value} += $3;
        $HashData{$2}{counter}++;

        if( !defined $network ){
            $network = $1;
            $network =~ s/(\w+)(\.)(.+)/$1/g;
#            print "$network\n";
        }
# print "$1\n";
    }
}

close(SCAFILE);
open(SCAFILE,">>$ARGV[0]");
foreach my $key( sort keys %HashData ){
    my $avg = $HashData{$key}{value} / $HashData{$key}{counter};
    print SCAFILE "scalar \"${network}.average\"\t\"$key\"\t$avg\n"
}

close(SCAFILE);

