/*
Copyright (C) 2007, 2008  Condel project, TU-Berlin.
Written by Jan Sablatnig, Sven Grottke, Jiehua Chen.

This file is part of Adam, the DVE testbed.

Adam is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation, either version 3, or (at your option) any later
version.

Adam is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Adam; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

Contact the Condel project at <http://www.math.tu-berlin.de/condel/>.
*/

#ifndef __SWARM_OPT_HOST_H
#define __SWARM_OPT_HOST_H

#include "host.hh"

namespace Condel
{

/// The host for Swarm with optimistic consistency.
/// This is the class that creates the entire optimistic consistency/swarm
/// system.
 
class cSwarmOptHost : public cHost
{
protected:
  unsigned long m_id;

public:
  /// The constructor.
  /// This sets cHost's component pointers to components instantiated here.
  /// The components chosen are cSwarmScenario, cOptConsistency, etc..
  cSwarmOptHost(void);
  virtual ~cSwarmOptHost(void) {}

  virtual void initialize(void);
};

};

#endif // __SWARM_OPT_HOST_H
