/*
Copyright (C) 2007, 2008  Condel project, TU-Berlin.
Written by Jan Sablatnig, Sven Grottke, Jiehua Chen.

This file is part of Adam, the DVE testbed.

Adam is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation, either version 3, or (at your option) any later
version.

Adam is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Adam; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

Contact the Condel project at <http://www.math.tu-berlin.de/condel/>.
*/
#include <math.h>

#include "load.hh"

cLoadMeter::cLoadMeter(void)
: m_CpuSum(0), m_CpuSumCount(0), m_memSum(0), m_memSumCount(0),
  m_CpuMax(0), m_memMax(0), m_CpuCurrent(0)
{ }

void cLoadMeter::initialize(void)
{
  m_CpuSum= 0;
  m_CpuSumCount= 0;
  m_memSum= 0;
  m_memSumCount= 0;
  m_CpuMax= 0;
  m_memMax= 0;
  m_CpuCurrent= 0;
}
  

void cLoadMeter::nextFrame(void)
{
  if (m_CpuCurrent >m_CpuMax)
    m_CpuMax = m_CpuCurrent;

  m_CpuSum += m_CpuCurrent;
  m_CpuSumCount ++;
  m_CpuCurrent = 0;
}
