/*
Copyright (C) 2007, 2008  Condel project, TU-Berlin.
Written by Jiehua Chen, Sven Grottke, Jan Sablatnig.

This file is part of Adam, the DVE testbed.

Adam is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation, either version 3, or (at your option) any later
version.

Adam is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Adam; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

Contact the Condel project at <http://www.math.tu-berlin.de/condel/>.
*/
// visu_swarm class-definitions

#ifndef VISU_SWARM_CPP_H
#define VISU_SWARM_CPP_H

#include <math.h>
// scoped_ptr etc.
#include <boost/smart_ptr.hpp>
using namespace boost;

struct beeState{
  double m_x;
  double m_y;
  double m_score;
  double m_dead;
  
  //beeState():m_x(INFINITY),m_y(INFINITY),m_score(INFINITY){}
  beeState(const double x=INFINITY,
           const double y=INFINITY,
           const double score=INFINITY,
           const double dead=INFINITY):
    m_x(x), m_y(y), m_score(score),m_dead(dead){}
};

struct queenState{
public:
  double m_x;
  double m_y;
  //queenState():m_x(INFINITY),m_y(INFINITY){}
  queenState(const double x=INFINITY, const double y=INFINITY):
    m_x(x), m_y(y){}
};

class View{
public:
  int m_nrBees;
  queenState m_queen;
  scoped_array<beeState> m_bees;

  View();
  View(const View& orig);

  void setNumberOfBees(const int nrBees);
};

class CurrentState{
public:
  double m_timestamp;
  int m_nrViews;
  scoped_array<View> m_views;

  CurrentState(const int nrViews, const int nrBees);
  CurrentState(const CurrentState& orig);
};

std::ostream& operator<<(std::ostream& os, const beeState& b);
std::ostream& operator<<(std::ostream& os, const queenState& q);
std::ostream& operator<<(std::ostream& os, const View& v);
std::ostream& operator<<(std::ostream& os, const CurrentState& cState);

#endif // end of VISU_SWARM_CPP_H

